VERSION 4.00
Begin VB.Form frmSearch 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Full Text Search"
   ClientHeight    =   4230
   ClientLeft      =   3060
   ClientTop       =   2535
   ClientWidth     =   7335
   ForeColor       =   &H00000000&
   Height          =   4635
   Icon            =   "search.frx":0000
   Left            =   3000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4230
   ScaleWidth      =   7335
   ShowInTaskbar   =   0   'False
   Top             =   2190
   Width           =   7455
   Begin VB.TextBox txtNear 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   12
      Text            =   "search.frx":000C
      Top             =   3720
      Width           =   735
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   6000
      TabIndex        =   7
      Top             =   960
      Width           =   1215
   End
   Begin VB.CommandButton cmdSearch 
      Caption         =   "Search"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   375
      Left            =   6000
      TabIndex        =   6
      Top             =   480
      Width           =   1215
   End
   Begin VB.Frame fraSearch 
      Caption         =   "Search Scope"
      Height          =   2295
      Left            =   120
      TabIndex        =   9
      Top             =   960
      Width           =   5655
      Begin VB.OptionButton optLast 
         Caption         =   "&Last Search"
         Height          =   255
         Left            =   120
         TabIndex        =   14
         Top             =   1440
         Width           =   1455
      End
      Begin VB.ListBox lbGroupList 
         Height          =   1425
         Left            =   1680
         MultiSelect     =   2  'Extended
         TabIndex        =   4
         Top             =   620
         Width           =   3735
      End
      Begin VB.OptionButton optAll 
         Caption         =   "&All Topics"
         Height          =   255
         Left            =   120
         TabIndex        =   3
         Top             =   360
         Value           =   -1  'True
         Width           =   1455
      End
      Begin VB.OptionButton optGroup 
         Caption         =   "Topic &Group"
         Height          =   255
         Left            =   120
         TabIndex        =   2
         Top             =   1080
         Width           =   1455
      End
      Begin VB.OptionButton optCurrent 
         Caption         =   "&Current Topic"
         Height          =   255
         Left            =   120
         TabIndex        =   1
         Top             =   720
         Width           =   1455
      End
      Begin VB.Label lblGroups 
         Caption         =   "Topic Grou&ps:"
         Height          =   255
         Left            =   1680
         TabIndex        =   10
         Top             =   360
         Width           =   2175
      End
   End
   Begin VB.CheckBox chkAnd 
      Caption         =   "&Find topics in which all of the search words can be found (AND operator)"
      Height          =   285
      Left            =   120
      TabIndex        =   5
      Top             =   3360
      Width           =   5775
   End
   Begin VB.TextBox txtSearch 
      Height          =   315
      Left            =   120
      TabIndex        =   0
      Top             =   480
      Width           =   5415
   End
   Begin VB.Label lblNear 
      Caption         =   "Search within how many words (NEAR operator threshold)"
      Height          =   255
      Left            =   1200
      TabIndex        =   13
      Top             =   3765
      Width           =   4575
   End
   Begin Spin.SpinButton spnNear 
      Height          =   315
      Left            =   900
      TabIndex        =   11
      Top             =   3720
      Width           =   195
      _Version        =   65536
      _ExtentX        =   344
      _ExtentY        =   556
      _StockProps     =   73
      ForeColor       =   8421376
      BorderThickness =   0
      LightColor      =   16777215
      ShadeColor      =   8421504
      TdThickness     =   2
   End
   Begin VB.Label lblSearch 
      Caption         =   "Type one or more &search words or a search phrase:"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   225
      Width           =   3975
   End
End
Attribute VB_Name = "frmSearch"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdCancel_Click()

    Unload Me

End Sub


Private Sub cmdSearch_Click()
    
    Dim i As Integer
    
    ' Store the Search dialog settings for next time
    gszSearch = txtSearch.Text
    gnNear = Val(txtNear.Text)
    gnAnd = chkAnd.Value
    
    ' If the ckbAnd check box is checked, search implicit AND
    frmMain.mvMain.SearchImplicitAND = chkAnd.Value
    
    ' Set the NEAR operator threshold
    frmMain.mvMain.SearchNearThreshold = gnNear
    
    ' Set the Search Scope
    If optCurrent Then
        frmMain.mvMain.SearchMode = SINGLE_TOPIC
    ElseIf optAll Then
        frmMain.mvMain.SearchMode = ENTIRE_TITLE
    ElseIf optLast Then
        frmMain.mvMain.SearchMode = LAST_SEARCHRESULTS
    ElseIf optGroup Then
        If Not TopicListFromGroups Then
            ' If the TopicListFromGroups sub failed, there were no groups selected
            Call MsgBox("You must select at least one group from the Topic  " & Chr$(13) & Chr$(10) _
                    & "Groups list when choosing the Topic Group option.  ", vbExclamation, "Full Text Search")
            ' Skip the search this time
            Exit Sub
        End If
    End If
    
    ' Hide the Search dialog
    Me.Hide
    
    ' Initiate the search
    frmMain.mvMain.InitiateSearch txtSearch.Text
    
    ' First check if there were any search hits
    If frmMain.mvMain.SearchHitCount = 0 Then
        
        Call MsgBox("There were no occurrences of " & Chr$(34) & txtSearch.Text _
                & Chr$(34) & " found.", vbExclamation, "Search Results")
    Else
        
        ' Clear the Search Results list box first
        frmSearchResults.lbSearchResults.Clear
                
        ' Disable the Search Results window's Goto button
        frmSearchResults.cmdGoto.Enabled = False
        
        ' Fill the Search Results list box with the new results
        For i = 0 To (frmMain.mvMain.SearchHitCount - 1)
            frmSearchResults.lbSearchResults.AddItem _
                frmMain.mvMain.SearchHitsTopicStrings(i)
            frmSearchResults.lbSearchResults.ItemData(frmSearchResults.lbSearchResults.NewIndex) _
                = frmMain.mvMain.SearchHitsTopicIDs(i)
        Next i
    
        ' Include the search string in the window caption of the Search Results window
        frmSearchResults.Caption = "Search Results - [" & txtSearch & "]"
        
        ' In case they're disabled, enable the Search Results button and menu
        frmMain.mnuSearchResults.Enabled = True
        frmMain.tbrMain.Buttons("SResults").Enabled = True
        
        ' If we searched more than just the current topic ...
        If Not optCurrent Then
            ' Show the Search Results window
            frmSearchResults.Show
        End If
    
    End If
    
    ' Now it's OK to unload the form
    Unload Me

End Sub

Private Sub Form_Load()
    
    Dim nGroup As Integer
    
    ' Restore the Search dialog values from the last search
    txtSearch.Text = gszSearch
    txtNear.Text = gnNear
    chkAnd.Value = gnAnd
    
    ' Center the form on the screen (False to center on app)
    Call CenterForm(Me, False)

    ' If there are no groups ...
    If Not UBound(Groups) > 0 Then
        ' Disable the group option button, list box, and label
        optGroup.Enabled = False
        lbGroupList.Enabled = False
        lblGroups.Enabled = False
    Else
        ' Otherwise, fill the group list box
        For nGroup = 0 To (UBound(Groups) - 1)
            lbGroupList.AddItem Groups(nGroup).Title
        Next nGroup
    End If

    ' If there was no "last search", disable the last search option button
    If frmSearchResults.lbSearchResults.ListCount = 0 Then
        optLast.Enabled = False
    End If

    ' Select the initial text in the Search text box
    txtSearch.SelLength = Len(txtSearch)

End Sub


Private Sub lbGroupList_Click()

    ' If an item in the Group list was selected, we assume the user
    ' wants to search a group, so automatically click the group option
    optGroup.Value = True

End Sub

Private Sub spnNear_SpinDown()
    
    ' Decrement the value by one.  The number is stored as text
    txtNear.Text = (Val(txtNear.Text) - 1)

End Sub

Private Sub spnNear_SpinUp()
    
    ' Increment the value by one.  The number is stored as text
    txtNear.Text = (Val(txtNear.Text) + 1)

End Sub


Private Sub txtNear_Change()

    Dim x As Integer
    
    If txtNear.Text = "" Then
        ' Do nothing.  This is the only case we accept a non-numeric value
    
    ElseIf Not IsNumeric(txtNear.Text) Then
        ' The text that was input couldn't be evaluated as a numeric value
        x = MsgBox("You must supply a numeric value.", vbExclamation, "Near Operator Value")
    
        ' Reset to the last known good value
        txtNear.Text = gnNear
    
    Else
        ' Check if we went past the limits
        If Val(txtNear.Text) > 32767 Then
            txtNear.Text = "32767"
        ElseIf Val(txtNear.Text) < 0 Then
            txtNear.Text = "0"
        End If
        
        ' Save this value
        gnNear = Val(txtNear.Text)
    
    End If
    
End Sub

Private Sub txtSearch_Change()

    ' If there's text in the search text box, enable the Search button
    cmdSearch.Enabled = Not (txtSearch.Text = "")

End Sub



Public Function TopicListFromGroups() As Boolean

    ' This routine gets called when the user chooses the Topic Group option
    ' button in the Search dialog.  For each topic group selected, we add
    ' its topics to the topic list, then use the TOPIC_LIST search mode

    Dim i As Long
    
    ' Check if there are any selected items in the group list ...
    If lbGroupList.SelCount = 0 Then
        ' Return and cancel the search
        TopicListFromGroups = False
        Exit Function
    End If
    
    ' Clear the topic list in case it isn't empty
    frmMain.mvMain.TopicListClear
    
    ' Add topics to the topic list using OR logic
    frmMain.mvMain.TopicListMode = TL_OR
    
    ' For each item in the groups list box ...
    For i = 0 To (lbGroupList.ListCount - 1)
        ' Check if the current item is selected ...
        If lbGroupList.Selected(i) Then
            ' Add the topics for the currently selected group to the topic list
            frmMain.mvMain.AddGroupToTopicList Groups(i).Filename
        End If
    Next i
    
    ' Then set the search scope to the topic list
    frmMain.mvMain.SearchMode = TOPIC_LIST

    TopicListFromGroups = True

End Function
