VERSION 4.00
Begin VB.Form frmSearchResults 
   Caption         =   "Search Results"
   ClientHeight    =   4860
   ClientLeft      =   990
   ClientTop       =   1770
   ClientWidth     =   5295
   Height          =   5265
   Icon            =   "sresults.frx":0000
   Left            =   930
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4860
   ScaleWidth      =   5295
   ShowInTaskbar   =   0   'False
   Top             =   1425
   Width           =   5415
   Begin VB.CheckBox chkKeep 
      Caption         =   "Keep Open"
      Height          =   255
      Left            =   3960
      TabIndex        =   4
      Top             =   1440
      Width           =   1215
   End
   Begin VB.ListBox lbSearchResults 
      Height          =   4350
      Left            =   120
      TabIndex        =   0
      Top             =   375
      Width           =   3495
   End
   Begin VB.CommandButton cmdGoTo 
      Caption         =   "Go To"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   375
      Left            =   3960
      TabIndex        =   1
      Top             =   375
      Width           =   1215
   End
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "Close"
      Height          =   375
      Left            =   3960
      TabIndex        =   2
      Top             =   855
      Width           =   1215
   End
   Begin VB.Label lblSearchResults 
      Caption         =   "Select a topic from the &list:"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   3495
   End
End
Attribute VB_Name = "frmSearchResults"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit


Private Sub cmdClose_Click()
    
    ' Unselect the list item, disable the Goto button, and hide the form
    Call SearchResultsHide(True)

End Sub


Private Sub cmdGoto_Click()

    'Store the current Topic Title, Index, VA and Scroll position
    StoreTopicInfo

    ' Jump to the topic selected in the list
    frmMain.mvMain.TopicIndex = _
        lbSearchResults.ItemData(lbSearchResults.ListIndex)

    ' Reset the current highlight index to the first one
    glHighlightIndex = 0

    ' Unselect the list item, disable the Goto button, and
    ' hide the form if the "Keep Open" check box isn't checked
    Call SearchResultsHide(False)
    
End Sub


Private Sub Form_Load()
    
    ' Center the form on the screen (False to center on app)
    Call CenterForm(Me, False)

End Sub


Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)

    ' If Close was clicked, don't actually close or else we'll
    ' lose all the search results data.  Just hide the form instead.
    If UnloadMode = vbFormControlMenu Then
        
        Cancel = True
        
        ' Unselect the list item, disable the Goto button, and hide the form
        Call SearchResultsHide(True)
    
    End If

End Sub


Private Sub Form_Resize()
    
    If Me.Width >= 3640 Then
        ' Widen the list as the form widens
        lbSearchResults.Width = Me.Width - 1920
        
        ' Keep the buttons along the right side of the form
        cmdGoto.Left = Me.Width - 1455
        cmdClose.Left = Me.Width - 1455
        chkKeep.Left = Me.Width - 1455
    Else
        ' Force the form's width back to a minimum size
        Me.Width = 3640
    End If

    If Me.Height >= 1950 Then
        ' Make the list taller as the form's height grows
        lbSearchResults.Height = Me.Height - 915
    Else
        ' Force the form's height back to a minimum size
        Me.Height = 1950
    End If

End Sub


Private Sub lbSearchResults_Click()

    ' Enable the Goto button
    cmdGoto.Enabled = True

End Sub


Private Sub lbSearchResults_DblClick()

    ' Jump to the topic that was double-clicked in the list
    cmdGoto_Click

End Sub



Public Sub SearchResultsHide(bCloseClicked As Boolean)
    
    ' Unselect the list item
    lbSearchResults.ListIndex = -1
    
    ' Disable the Goto button
    cmdGoto.Enabled = False
        
    If bCloseClicked Then
        ' In case it's checked, uncheck the "Keep Open" check box
        chkKeep.Value = 0
    End If
    
    ' If the Close button was clicked or the "Keep
    ' Open" check box is unchecked, hide the form
    If bCloseClicked Or chkKeep.Value = 0 Then
        ' Hide the Search Results window
        Me.Hide
    End If

End Sub
